package sim;

import java.io.File;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.filechooser.FileFilter;
import javax.swing.DefaultListModel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;

import sim.splitaudiovideo.src.Split;
import sim.splitframes.src.SplitAsFrames;
import umts.UMTSProcess;

import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;

public class SenderHome extends JFrame {
	private JPanel jContentPane = null;
	private JPanel jPanel = null;
	private JLabel jLabel = null;
	private JPanel jPanel1 = null;
	private JButton jButtonSend = null;
	private JButton jButtonCancel = null;
	private JLabel jLabel2 = null;
	private JList jListHostNames = null;
	private JScrollPane jScrollPane = null;
	private JComboBox jComboBoxFileNames = null;
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jLabel2 = new JLabel();
			jLabel2.setBounds(new java.awt.Rectangle(13,60,149,22));
			jLabel2.setText("Destination Host Name :");
			jLabel = new JLabel();
			jLabel.setText("Browse File :"); //$NON-NLS-1$
			jLabel.setBounds(new java.awt.Rectangle(17,16,77,25));
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jPanel.setBounds(new java.awt.Rectangle(44,17,583,218));
			jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createLineBorder(new java.awt.Color(204,255,204),5)), "File Transfer", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null)); //$NON-NLS-1$
			jPanel.add(jLabel, null);
			jPanel.add(getJPanel1(), null);
			jPanel.add(jLabel2, null);
			jPanel.add(getJScrollPane(), null);
			jPanel.add(getJComboBoxFileNames(), null);
		}
		return jPanel;
	}
	
	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(null);
			jPanel1.setBounds(new java.awt.Rectangle(150,160,261,36));
			jPanel1.add(getJButtonSend(), null);
			jPanel1.add(getJButtonExit(), null);
		}
		return jPanel1;
	}
	
	/**
	 * This method initializes jButtonSend	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonSend() {
		if (jButtonSend == null) {
			jButtonSend = new JButton();
			jButtonSend.setBounds(new java.awt.Rectangle(9,8,113,20));
			jButtonSend.setText("Send"); //$NON-NLS-1$
			jButtonSend.setName("Send"); //$NON-NLS-1$
			jButtonSend.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					String fileName[] = {jComboBoxFileNames.getSelectedItem().toString()};
					//split the media as video and audio
					new Split(fileName);
					SimulationLog.write("The Selected " + fileName[0] +"file is splitted as Audio and Vidoe");
					// splitted as frames
					new SplitAsFrames("split-files/split-vid0.mov").convertImageArray();
					SimulationLog.write("The splitted video file is coverted as jpeg frame format");
					Object object[]=jListHostNames.getSelectedValues();
					String str[]=new String[object.length];
					for(int i=0;i<object.length;i++){
						str[i]=object[i].toString();
						System.out.println(str[i]);
					}
					SimulationLog.write("UMTS process is started to transfer the selected file");
					new UMTSProcess().startProcess(str,jComboBoxFileNames.getSelectedItem().toString());
				}
			});
		}
		return jButtonSend;
	}
	
	/**
	 * This method initializes jButtonExit	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonExit() {
		if (jButtonCancel == null) {
			jButtonCancel = new JButton();
			jButtonCancel.setBounds(new java.awt.Rectangle(142,8,105,22));
			jButtonCancel.setText("Cancel"); //$NON-NLS-1$
			final JFrame frame = this;
			jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					frame.setVisible(false);
				}
			});
		}
		return jButtonCancel;
	}
	
	/**
	 * This method initializes jListHostNames	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getJListHostNames() {
		if (jListHostNames == null) {
			jListHostNames = new JList();
		}
		return jListHostNames;
	}
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setBounds(new java.awt.Rectangle(178,59,274,85));
			jScrollPane.setViewportView(getJListHostNames());
		}
		return jScrollPane;
	}
	
	private void addFileNames(){
		File file[] = new File("avi-files").listFiles();
		
		for(int i = 0;i<file.length;i++){
			jComboBoxFileNames.addItem(file[i].getName());
		}
	}
	/**
	 * This method initializes jComboBoxFileNames	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBoxFileNames() {
		if (jComboBoxFileNames == null) {
			jComboBoxFileNames = new JComboBox();
			jComboBoxFileNames.setBounds(new java.awt.Rectangle(106,17,341,25));
		}
		return jComboBoxFileNames;
	}

	/**
	 * @param args
	 */
	
	public static void main(String args[]) {
		// TODO Auto-generated method stub
		new SenderHome();
	}
	
	/**
	 * This is the default constructor
	 */
	public SenderHome() {
		super();
		initialize();
		jListHostNames.setListData(Simulation.getMobileHostName());
		addFileNames();
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(668, 324);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame"); //$NON-NLS-1$
		this.setVisible(true);
	}
	
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJPanel(), null);
		}
		return jContentPane;
	}
	
}  //  @jve:decl-index=0:visual-constraint="8,3"
